#include "solidtest.h"

#include <QtGui/QLabel>
#include <QtGui/QMenu>
#include <QtGui/QMenuBar>
#include <QtGui/QAction>

#include <KConfigGroup>
#include <solid/device.h>
#include <solid/deviceinterface.h>
#include <solid/devicenotifier.h>
#include <solid/genericinterface.h>
#include <solid/opticaldisc.h>
#include <solid/portablemediaplayer.h>
#include <solid/storageaccess.h>
#include <solid/storagedrive.h>
#include <solid/block.h>
#include <solid/storagevolume.h>

#include <kdeversion.h>

#if KDE_IS_VERSION(4,4,99)
#include <kmountpoint.h>
#endif

solidtest::solidtest()
{
    QLabel* l = new QLabel( this );
    l->setText( "Hello World!" );
    setCentralWidget( l );
    QAction* a = new QAction(this);
    a->setText( "Quit" );
    connect(a, SIGNAL(triggered()), SLOT(close()) );
    menuBar()->addMenu( "File" )->addAction( a );
	
    connect(&m_timer, SIGNAL(timeout()), this, SLOT(slotTimeout()));

    m_timer.setSingleShot(true);
    m_timer.start(1000);
	
}

solidtest::~solidtest()
{}


void solidtest::slotTimeout()
{
#if KDE_IS_VERSION(4,4,99)
    KMountPoint::List possibleMountList = KMountPoint::possibleMountPoints();
    KMountPoint::List currentMountList = KMountPoint::currentMountPoints();
    QList<Solid::Device> deviceList = Solid::Device::listFromType( Solid::DeviceInterface::StorageAccess );

    for (KMountPoint::List::iterator it = possibleMountList.begin(); it != possibleMountList.end(); ++it) {
        if ((*it)->mountType() == "nfs" || (*it)->mountType() == "nfs4" || 
            (*it)->mountType() == "smb" || (*it)->mountType() == "cifs") {
            QString path = (*it)->mountPoint();
            bool mounted = false;
            QString udi = QString();

            foreach( const Solid::Device &device, deviceList )
            {
                const Solid::StorageAccess* ssa = device.as<Solid::StorageAccess>();
                if( ssa && path == ssa->filePath())
                    udi = device.udi();
            }

            for (KMountPoint::List::iterator it2 = currentMountList.begin(); it2 != currentMountList.end(); ++it2) {
                if ( (*it)->mountType() == (*it2)->mountType() &&
                     (*it)->mountPoint() == (*it2)->mountPoint() ) {
                    mounted = true;
                    break;
                }
            }

        }
    }
#endif

    m_timer.setSingleShot(true);
    m_timer.start(1000);
}


#include "solidtest.moc"
